// DemoProgram.cpp : C vWFNg t@CłB

#include "stdafx.h"
#include "RNP2to191.h"

using namespace System;
using namespace rnp2to191;

int main(array<System::String ^> ^args)
{
	RNP2to191 rn;
	const int NSamples = 10000;
	//
	//				Parameter values of prior distributions
	//
	double a1 = 3, b1 = 3, a2 = 3, b2 = 3;
	//
	//				Data 
	//
	int N1 = 7, z1 = 5, N2 = 7, z2 = 2;

	double theta1[NSamples + 1], theta2[NSamples + 1], thetaDiff[NSamples + 1];
	theta1[0] = theta2[0] = 0.5;
	thetaDiff[0] = theta1[0] - theta2[0];
	for (int t = 1; t <= NSamples; t++){
		//
		//			Gibbs sampling
		//
		theta1[t] = rn.beta( z1 + a1, N1 - z1 + b1 );
		theta2[t] = rn.beta( z2 + a2, N2 - z2 + b2 );
		thetaDiff[t] = theta1[t] - theta2[t];
		//
		//			Displaying the sampled values
		//
		int pos1 = int(theta1[t] * 50), pos2 = int(theta2[t] * 50);
		Console::Write(t.ToString()->PadLeft(6) + ": ");
		if (pos1 < pos2){
			Console::WriteLine(String("1").PadLeft(pos1) + String("2").PadLeft(pos2 - pos1));
		}else if (pos1 > pos2){
			Console::WriteLine(String("2").PadLeft(pos2) + String("1").PadLeft(pos1 - pos2));
		}else{
			Console::WriteLine(String("X").PadLeft(pos1));
		}
	}
	Console::WriteLine();
	double sum = 0.0;
	int n_greater0;
	int freq[27];
	for (int i = 0; i < 27; i++) freq[i] = 0;
	for (int t = 1; t <= NSamples; t++){
		//
		//			Sum of thetaDiff = theta1 - theta2
		//
		sum += thetaDiff[t];
		//
		//			Number of thetaDiff > 0
		//
		if (thetaDiff[t] > 0.0) n_greater0++;
		//
		//			Counting values for a histogram
		//
		int pos = int((thetaDiff[t] + 0.4 + 0.025) / 0.05);
		if (pos < 0.0){
			freq[0]++;
		}else if(pos > 24){
			freq[26]++;
		}else{
			freq[pos+1]++;
		}
	}
	double mean = sum / NSamples;
	Console::WriteLine("Mean = " + mean.ToString());
	Console::WriteLine("Prob( diff. > 0.0) = " + (double(n_greater0) / NSamples).ToString("F5"));
	Console::WriteLine();
	Console::WriteLine("Histogram of theta1 - theta2");
	int nmax = 0;
	for (int i = 0; i < 26; i++)
		if (nmax < freq[i]) nmax = freq[i];
	for (int ix = 1; ix <= 25; ix++){
		Console::Write((-0.4 + (ix - 1)*0.05).ToString("F2")->PadLeft(6) + " I");
		for (int i = 0; i < int(freq[ix] * 50.0 / nmax); i++)
			Console::Write("X");
		Console::WriteLine();
	}

	Console::WriteLine();
	Console::WriteLine("Press Enter key to exit.");
	Console::ReadLine();
    return 0;
}
